/*
 * Escreve uma mensagem antes de morrer.
 */

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void trata_SIGTERM(int signum) {
  if (fork()) {
    printf("Voc me matou, mas meu filho continuar a tradio da famlia!\n");
    signal(SIGTERM, SIG_DFL);
    raise(SIGTERM);
  } 
}

int main() {
  printf("Meu pid : %d\n", getpid());
  signal(SIGTERM, trata_SIGTERM);
  pause();  /* Interrompe a execuo, esperando um sinal */ 
  return 0;
}
